# Random Walk Neural Networks (PyTorch)

## Setup

Using ```Dockerfile```

```bash
docker build --no-cache --tag random-walk:latest .
docker run -it --gpus all --ipc host --name random-walk -v /home:/home random-walk:latest bash
# upon completion, you should be at /random-walk inside the container
```

## Running Experiments

Synthetic experiments (Section 5.1)

```bash
cd src_synthetic
python3 test_walk_statistics.py
bash mixing.sh
bash mixing_mlp.sh
bash mixing_crawl.sh
bash mixing_walklm.sh
cd ..
```

Graph isomorphism learning (Section 5.2)

```bash
python3 main.py --config configs/[experiment].json
```

Real-world transductive classification (Section 5.3)

```bash
cd src_transductive
cd llama3
bash download.sh
cd ..
bash run_arxiv.sh
python3 parse_results_arxiv.py --root experiments/[experiment] --n_preds 5
```

## References

- [graph-walker](https://github.com/kerighan/graph-walker) for random walks
